#*******************************************************************************
#******************PROGRAM sphere_SHS_angle******************************************
#*******************************************************************************
#   PySHS - An open source software about Second Harmonic Scattering 
#   developed at Institut Charles Gerhardt Montpellier - ENSCM
#   Dr Pierre-Marie GASSIN
#   Dr Gassin GASSIN
#    (june 2020)  
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#*******************************************************************************

#********************************************************************************
#
# 
#  
#********************************************************************************

#*******************************************************************************
# IMPORT MODULES
#*******************************************************************************

import matplotlib.pyplot as plt
import numpy as np
import matplotlib as mpl
import sys
from scipy.integrate import dblquad
from mpl_toolkits.mplot3d import Axes3D


ukv=sys.argv[1]
uuu=sys.argv[2]
uuv=sys.argv[2]+".pdf"

print("********************************************************")
print("****           PySHS: An open source software       ****")
print("****         about Second Harmonic Scattering       ****") 
print("**** Dr Pierre-Marie GASSIN and Dr Gaelle GASSIN    ****")          
print("****                  ICGM - ENSCM                  ****") 
print('****                   june 2020                    ****')
print("********************************************************")

n=float(input("refractive index of the medium?"))
longueuronde=float(input("wavelength of the incident laser beam (expressed in nm)?"))
R=float(input("Radius of the sphere in nm?"))
pas2=int(input("number of points between 0 and 180°? \n"))
petitk=2*np.pi*n/longueuronde
grandk=4*np.pi*n/longueuronde
pas=15


def Rphi(phi):
    aaa=np.array([[np.cos(phi),-np.sin(phi),0],[np.sin(phi),np.cos(phi),0],[0,0,1]])
    return aaa

def Rtheta(theta):
    bb=np.array([[1,0,0],[0,np.cos(theta),-np.sin(theta)],[0,np.sin(theta),np.cos(theta)]])
    return bb

def Rpsi(psi):
    cc=np.array([[np.cos(psi),-np.sin(psi),0],[np.sin(psi),np.cos(psi),0],[0,0,1]])
    return cc


def T(phi,theta,psi):
    zz=np.dot(np.linalg.inv(Rphi(phi)), np.dot(np.linalg.inv(Rtheta(theta)),np.linalg.inv(Rpsi(psi))))
    return zz

def kimesoijk(phi,theta,psi,i,j,k):
    uuu=0
    uuu=(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,0]*beta[0,0,0])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,1]*beta[0,0,1])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,2]*beta[0,0,2])+\
    (T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,0]*beta[0,1,0])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,1]*beta[0,1,1])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,2]*beta[0,1,2])+\
    (T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,0]*beta[0,2,0])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,1]*beta[0,2,1])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,2]*beta[0,2,2])+\
    (T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,0]*beta[1,0,0])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,1]*beta[1,0,1])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,2]*beta[1,0,2])+\
    (T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,0]*beta[1,1,0])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,1]*beta[1,1,1])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,2]*beta[1,1,2])+\
    (T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,0]*beta[1,2,0])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,1]*beta[1,2,1])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,2]*beta[1,2,2])+\
    (T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,0]*beta[2,0,0])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,1]*beta[2,0,1])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,2]*beta[2,0,2])+\
    (T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,0]*beta[2,1,0])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,1]*beta[2,1,1])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,2]*beta[2,1,2])+\
    (T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,0]*beta[2,2,0])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,1]*beta[2,2,1])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,2]*beta[2,2,2])
    return uuu

def grandgammaxxx(phic,thetac,grandtheta):
    uuu=complex(0,0)
    uuu=R*R*kimesoijk(phic,thetac,0,0,0,0)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammazxx(phic,thetac,grandtheta):
    uuu=complex(0,0)
    uuu=R*R*kimesoijk(phic,thetac,0,2,0,0)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammayxx(phic,thetac,grandtheta):
    uuu=complex(0,0)
    uuu=R*R*kimesoijk(phic,thetac,0,1,0,0)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammazyy(phic,thetac,grandtheta):
    uuu=complex(0,0)
    uuu=R*R*kimesoijk(phic,thetac,0,2,1,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammayyy(phic,thetac,grandtheta):
    uuu=complex(0,0)
    uuu=R*R*kimesoijk(phic,thetac,0,1,1,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammaxyy(phic,thetac,grandtheta):
    uuu=complex(0,0)
    uuu=R*R*kimesoijk(phic,thetac,0,0,1,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu




beta=np.zeros((3,3,3))
#A CHANGER EN KISURF
beta=np.zeros((3,3,3))
with open(ukv,'r') as f:
    datacomments=f.readlines()[0]

kk=0
data=[0]*27
value=[0]*27
beta=np.zeros((3,3,3))
for i in range(3):
    for j in range(3):
        for k in range(3):
            with open(ukv,'r') as f:
                data[kk]=f.readlines()[kk+1]
                value[kk] = data[kk].split()
                beta[i,j,k]=float(value[kk][1])
                kk=kk+1

print(f" input surface nonlinear susceptibility tensor: \n {beta}")
print("********** Begin calculation **************")

with open(uuu, "w") as f:
    f.write(" ************************************************************* \n")
    f.write(" *******************program sphere_SHS_angle****************** \n")
    f.write(" ************************************************************* \n")
    f.write("  \n")
    f.write("  \n")
    f.write(" ********Contributors : Pierre-Marie  &  Gaelle Gassin ********\n")
    f.write("  \n")
    f.write("  \n")
    f.write(" ********************INPUT***************************** \n")
    f.write("  \n")
    f.write(f" radius of the sphere in nm: {R}\n")
    f.write(f" refractive index of the medium: {n}\n")
    f.write(f" wavelength of the incident laser beam (expressed in nm): {longueuronde}\n")
    f.write(f" {datacomments} \n")
    f.write(f" second order surface susceptibility tensor:   \n")
    f.write(f" {beta} \n")
    f.write("  \n")
    f.write(" ****************OUTPUT****************************************\n")
    f.write(f" grandtheta IPSS-IH(0°) IPPP-IH(90°) ISSS-IV(0°) ISPP-IV(90°) \n")  



grandthetat=np.zeros(2*(pas2)+1)
grandthetadegree=np.zeros(2*(pas2)+1)
ISSS=np.zeros(2*(pas2)+1)
IPPP=np.zeros(2*(pas2)+1)
ISPP=np.zeros(2*(pas2)+1)
IPSS=np.zeros(2*(pas2)+1)

hx = (2*np.pi)/float(pas)
hy = (np.pi)/float(pas)
hz = (2*np.pi)/float(pas)
nx=pas
ny=pas
nz=pas


for mmm in range(2*(pas2)+1):
    grandtheta=-np.pi+mmm*np.pi/pas2
    grandthetat[mmm]=grandtheta
    grandthetadegree[mmm]=grandtheta*360/(2*np.pi)
    grandgammazxx_moy=0
    grandgammayyy_moy=0
    grandgammazyy_moy=0
    grandgammaxxx_moy=0
    grandgammaxyy_moy=0
    grandgammayxx_moy=0
    print(f'calculation in progress - grandtheta: {grandtheta*360/(2*np.pi):.5f}')
    for i in range(nx):
        fgf=float(i/nx)*100
        for j in range(ny):
            xi = 0 + hx/2 + i*hx
            yj = 0 + hy/2 + j*hy
            grandgammazxx_moy=grandgammazxx_moy+hx*hy*grandgammazxx(xi, yj,grandtheta)
            grandgammaxxx_moy=grandgammaxxx_moy+hx*hy*grandgammaxxx(xi, yj,grandtheta)
            grandgammayxx_moy=grandgammayxx_moy+hx*hy*grandgammayxx(xi, yj,grandtheta)
            grandgammaxyy_moy=grandgammaxyy_moy+hx*hy*grandgammaxyy(xi, yj,grandtheta)
            grandgammazyy_moy=grandgammazyy_moy+hx*hy*grandgammazyy(xi, yj,grandtheta)
            grandgammayyy_moy=grandgammayyy_moy+hx*hy*grandgammayyy(xi, yj,grandtheta)
    ISSS[mmm]=(grandgammaxxx_moy*np.conjugate(grandgammaxxx_moy)).real
    ISPP[mmm]=(grandgammaxyy_moy*np.conjugate(grandgammaxyy_moy)).real   
    Iy0=(grandgammayxx_moy*(np.cos(grandtheta)**2)-grandgammazxx_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))*np.conjugate(grandgammayxx_moy*(np.cos(grandtheta)**2)-grandgammazxx_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))
    Iz0=(-grandgammayxx_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazxx_moy*(np.sin(grandtheta))**2)*np.conjugate(-grandgammayxx_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazxx_moy*(np.sin(grandtheta))**2)
    IPSS[mmm]=(np.sqrt(Iy0**2+Iz0**2)).real
    Iy90=(grandgammayyy_moy*(np.cos(grandtheta)**2)-grandgammazyy_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))*np.conjugate(grandgammayyy_moy*(np.cos(grandtheta)**2)-grandgammazyy_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))
    Iz90=(-grandgammayyy_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazyy_moy*(np.sin(grandtheta))**2)*np.conjugate(-grandgammayyy_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazyy_moy*(np.sin(grandtheta))**2)
    IPPP[mmm]=(np.sqrt(Iy90**2+Iz90**2)).real
    with open(uuu, "a") as f:   
        f.write(f"{grandthetadegree[mmm]:.3f}   {IPSS[mmm]:.3f}   {IPPP[mmm]:.3f}    {ISSS[mmm]:.3f}   {ISPP[mmm]:.3f} \n")   

print(f'calculation finished - Have a nice day!')
plt.plot(grandthetadegree,IPSS,label='IPSS-IH(0°)')
plt.plot(grandthetadegree,IPPP,label='IPPP-IH(90°)')
plt.plot(grandthetadegree,ISSS,label='ISSS-IV(0°)')
plt.plot(grandthetadegree,ISPP,label='ISPP-IV(90°)')
plt.legend(loc='upper left')
plt.xlabel('scattering angle[°]')
plt.ylabel('SHS Intensity [a.u]')
plt.savefig(uuv)
plt.show()





 

