#*******************************************************************************
#******************PROGRAM sphere_SHS_polar_90**********************************
#*******************************************************************************
#   PySHS - An open source software about Second Harmonic Scattering 
#   developed at Institut Charles Gerhardt Montpellier - ENSCM
#   Dr Pierre-Marie GASSIN
#   Dr Gassin GASSIN
#    (june 2020)  
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#*******************************************************************************

#********************************************************************************
#
# 
#  
#********************************************************************************

#*******************************************************************************
# IMPORT MODULES
#*******************************************************************************

import matplotlib.pyplot as plt
import numpy as np
import matplotlib as mpl
import sys
from scipy.integrate import dblquad
from mpl_toolkits.mplot3d import Axes3D

ukv=sys.argv[1]
uuu=sys.argv[2]

print("********************************************************")
print("****           PySHS: An open source software       ****")
print("****         about Second Harmonic Scattering       ****") 
print("**** Dr Pierre-Marie GASSIN and Dr Gaelle GASSIN    ****")          
print("****                  ICGM - ENSCM                  ****") 
print('****                   june 2020                    ****')
print("********************************************************")

n=float(input("refractive index of the medium?"))
longueuronde=float(input("wavelength of the incident laser beam (expressed in nm)?"))
grandtheta=90
R=float(input("Radius of the sphere in nm?"))
petitk=2*np.pi*n/longueuronde
grandk=4*np.pi*n/longueuronde
pas=15
grandtheta=grandtheta*2*np.pi/360

def Rphi(phi):
    aaa=np.array([[np.cos(phi),-np.sin(phi),0],[np.sin(phi),np.cos(phi),0],[0,0,1]])
    return aaa

def Rtheta(theta):
    bb=np.array([[1,0,0],[0,np.cos(theta),-np.sin(theta)],[0,np.sin(theta),np.cos(theta)]])
    return bb

def Rpsi(psi):
    cc=np.array([[np.cos(psi),-np.sin(psi),0],[np.sin(psi),np.cos(psi),0],[0,0,1]])
    return cc

def T(phi,theta,psi):
    zz=np.dot(np.linalg.inv(Rphi(phi)), np.dot(np.linalg.inv(Rtheta(theta)),np.linalg.inv(Rpsi(psi))))
    return zz

def kimesoijk(phi,theta,psi,i,j,k):
    uuu=0
    uuu=(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,0]*beta[0,0,0])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,1]*beta[0,0,1])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,2]*beta[0,0,2])+\
    (T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,0]*beta[0,1,0])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,1]*beta[0,1,1])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,2]*beta[0,1,2])+\
    (T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,0]*beta[0,2,0])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,1]*beta[0,2,1])+(T(phi,theta,psi)[i,0]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,2]*beta[0,2,2])+\
    (T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,0]*beta[1,0,0])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,1]*beta[1,0,1])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,2]*beta[1,0,2])+\
    (T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,0]*beta[1,1,0])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,1]*beta[1,1,1])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,2]*beta[1,1,2])+\
    (T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,0]*beta[1,2,0])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,1]*beta[1,2,1])+(T(phi,theta,psi)[i,1]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,2]*beta[1,2,2])+\
    (T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,0]*beta[2,0,0])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,1]*beta[2,0,1])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,0]*T(phi,theta,psi)[k,2]*beta[2,0,2])+\
    (T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,0]*beta[2,1,0])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,1]*beta[2,1,1])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,1]*T(phi,theta,psi)[k,2]*beta[2,1,2])+\
    (T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,0]*beta[2,2,0])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,1]*beta[2,2,1])+(T(phi,theta,psi)[i,2]*T(phi,theta,psi)[j,2]*T(phi,theta,psi)[k,2]*beta[2,2,2])
    return uuu

def grandgammaxxx(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,0,0,0)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammazxx(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,2,0,0)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammayxx(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,1,0,0)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammazyy(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,2,1,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammayyy(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,1,1,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammaxyy(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,0,1,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammaxxy(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,0,0,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammazxy(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,2,0,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

def grandgammayxy(phic,thetac,grandtheta):
    uuu=0
    uuu=R*R*kimesoijk(phic,thetac,0,1,0,1)*np.sin(thetac)*np.exp(complex(0,(-2*petitk+grandk*np.cos(grandtheta))*R*np.cos(thetac)+(grandk*np.sin(grandtheta)*R*np.sin(thetac)*np.sin(phic))))
    return uuu

beta=np.zeros((3,3,3))
with open(ukv,'r') as f:
    datacomments=f.readlines()[0]

kk=0
data=[0]*27
value=[0]*27
beta=np.zeros((3,3,3))
for i in range(3):
    for j in range(3):
        for k in range(3):
            with open(ukv,'r') as f:
                data[kk]=f.readlines()[kk+1]
                value[kk] = data[kk].split()
                beta[i,j,k]=float(value[kk][1])
                kk=kk+1

print(f" input surface nonlinear susceptibility tensor: \n {beta}")

print("********** Begin calculation **************")
av=0
cv=0
bv=0
ah=0
bh=0
ch=0

hx = (2*np.pi)/float(pas)
hy = (np.pi)/float(pas)
nx=pas
ny=pas

grandgammazxx_moy=0
grandgammayyy_moy=0
grandgammazyy_moy=0
grandgammaxxx_moy=0
grandgammayxx_moy=0
grandgammayxy_moy=0
grandgammaxyy_moy=0
grandgammaxxy_moy=0
grandgammazxy_moy=0

for i in range(nx):
    fgf=float(i/nx)*100
    for j in range(ny):
        xi = 0 + hx/2 + i*hx
        yj = 0 + hy/2 + j*hy
        grandgammazxx_moy=grandgammazxx_moy+hx*hy*grandgammazxx(xi, yj,grandtheta)
        grandgammaxxx_moy=grandgammaxxx_moy+hx*hy*grandgammaxxx(xi, yj,grandtheta)
        grandgammayxx_moy=grandgammayxx_moy+hx*hy*grandgammayxx(xi, yj,grandtheta)
        grandgammaxyy_moy=grandgammaxyy_moy+hx*hy*grandgammaxyy(xi, yj,grandtheta)
        grandgammazyy_moy=grandgammazyy_moy+hx*hy*grandgammazyy(xi, yj,grandtheta)
        grandgammayyy_moy=grandgammayyy_moy+hx*hy*grandgammayyy(xi, yj,grandtheta)
        grandgammaxxy_moy=grandgammaxxy_moy+hx*hy*grandgammaxxy(xi, yj,grandtheta)
        grandgammayxy_moy=grandgammayxy_moy+hx*hy*grandgammayxy(xi, yj,grandtheta)
        grandgammazxy_moy=grandgammazxy_moy+hx*hy*grandgammazxy(xi, yj,grandtheta)
           
av=(grandgammaxxx_moy*np.conjugate(grandgammaxxx_moy)).real
cv=(grandgammaxyy_moy*np.conjugate(grandgammaxyy_moy)).real
bv=(4*grandgammaxxy_moy*np.conjugate(grandgammaxxy_moy)+grandgammaxxx_moy*np.conjugate(grandgammaxyy_moy)+grandgammaxyy_moy*np.conjugate(grandgammaxxx_moy)).real
bh=(4*grandgammazxy_moy*np.conjugate(grandgammazxy_moy)+grandgammazxx_moy*np.conjugate(grandgammazyy_moy)+grandgammazyy_moy*np.conjugate(grandgammazxx_moy)).real
Iy0=(grandgammayxx_moy*(np.cos(grandtheta)**2)-grandgammazxx_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))*np.conjugate(grandgammayxx_moy*(np.cos(grandtheta)**2)-grandgammazxx_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))
Iz0=(-grandgammayxx_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazxx_moy*(np.sin(grandtheta))**2)*np.conjugate(-grandgammayxx_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazxx_moy*(np.sin(grandtheta))**2)
ah=(np.sqrt(Iy0**2+Iz0**2)).real
Iy90=(grandgammayyy_moy*(np.cos(grandtheta)**2)-grandgammazyy_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))*np.conjugate(grandgammayyy_moy*(np.cos(grandtheta)**2)-grandgammazyy_moy*(np.cos(grandtheta))*(np.sin(grandtheta)))
Iz90=(-grandgammayyy_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazyy_moy*(np.sin(grandtheta))**2)*np.conjugate(-grandgammayyy_moy*(np.cos(grandtheta)*np.sin(grandtheta))+grandgammazyy_moy*(np.sin(grandtheta))**2)
ch=(np.sqrt(Iy90**2+Iz90**2)).real

print("**********calculation complete ************")           
print(f"av = {av:.5f}")
print(f"bv = {bv:.5f}")
print(f"cv = {cv:.5f}")
print(f"ah = {ah:.5f}")
print(f"bh = {bh:.5f}")
print(f"ch = {ch:.5f}")

I4v=(av-bv+cv)/(3*av+bv+3*cv)
I2v=(4)*(av-cv)/(3*av+bv+3*cv)
I4h=(ah-bh+ch)/(3*ah+bh+3*ch)
I2h=(4)*(ah-ch)/(3*ah+bh+3*ch)

print(f"I2v = {I2v:.5f}")
print(f"I4v = {I4v:.5f}")
print(f"I2h = {I2h:.5f}")
print(f"I4h = {I4h:.5f}")

with open(uuu, "w") as f:        
    f.write(" ********************************************************* \n")
    f.write(" ************program sphere_polar_90********************** \n")
    f.write(" ********************************************************* \n")
    f.write("  \n")
    f.write("  \n")
    f.write(" Contributors : Pierre-Marie Gassin  &  Gaelle Gassin \n")
    f.write("  \n")
    f.write("  \n")
    f.write(" ********************INPUT***************************** \n")
    f.write("  \n")
    f.write(f" radius of the sphere in nm: {R}\n")
    f.write(f" refractive index of the medium: {n}\n")
    f.write(f" wavelength of the incident laser beam (expressed in nm): {longueuronde}\n")
    f.write(f" observation angle in degree: {grandtheta}\n")
    f.write(f" {datacomments} \n")
    f.write(f" second order surface susceptibility tensor:   \n")
    f.write(f" {beta} \n")
    f.write("  \n")
    f.write(" ****************OUTPUT*******************************\n")
    f.write("  \n")
    f.write("  \n")
    f.write("av %12.6f\n" % av)
    f.write("bv %12.6f\n" % bv)
    f.write("cv %12.6f\n" % cv)
    f.write("ah %12.6f\n" % ah)
    f.write("bh %12.6f\n" % bh)
    f.write("ch %12.6f\n" % ch)
    f.write("  \n")
    f.write("*************************************************\n")
    f.write("  \n")
    f.write("I2v %12.6f\n" % I2v)
    f.write("I4v %12.6f\n" % I4v)
    f.write("I2h %12.6f\n" % I2h)   
    f.write("I4h %12.6f\n" % I4h)
    f.write("  \n")
    f.write("*************************************************\n")
    f.write("Have a nice day and enjoy the life!")


gammaa=np.linspace(0,2*np.pi,100)
plt.plot(gammaa*360/(2*np.pi),(av)*((np.cos(gammaa))**4)+(bv)*((np.cos(gammaa))**2)*((np.sin(gammaa))**2)+(cv)*((np.sin(gammaa))**4),label='polarV_out')#+(bv1)*((np.cos(gammaa))**3)*((np.sin(gammaa)))+(bv2)*((np.cos(gammaa)))*((np.sin(gammaa))**3)+(cv)*((np.sin(gammaa))**4))
plt.plot(gammaa*360/(2*np.pi),(ah)*((np.cos(gammaa))**4)+(bh)*((np.cos(gammaa))**2)*((np.sin(gammaa))**2)+(ch)*((np.sin(gammaa))**4),label='polarH_out')#+(bh1)*((np.cos(gammaa))**3)*((np.sin(gammaa)))+(bh2)*((np.cos(gammaa)))*((np.sin(gammaa))**3)+(ch)*((np.sin(gammaa))**4))
plt.legend(loc='upper left')
plt.ylabel("SHS Intensity in the forward direction (180°)")
plt.xlabel("polarization angle [degree]")
plt.savefig(uuu)
plt.show()

 

